/* diff.c - diff plugin.
 *
 * Copyright (C) 1998 Chris Lahey.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <string.h>

#include "client.h"
#include <glib.h>

int main( int argc, char *argv[] )
{

  /*  char buff[1025]; */
  /*  int fdpipe[2]; */
  int pid;
  char *filename = NULL;
  int docid;
  /*  int length; */
  int context;
  client_info info = empty_info;

  info.menu_location = "[Plugins]Print";
  info.suggested_accelerator = "<control>P";

  context = client_init( &argc, &argv, &info );

  docid = client_document_current( context );
  filename = client_document_filename( docid );
 
  pid = fork();
  if ( pid == 0 )
    {
      /* New process. */
      char *argv[3];
      
      argv[0] = g_strdup( "lpr" );
      argv[1] = filename;
      argv[2] = NULL;
      execv( "/usr/bin/lpr", argv );
      /* This is only reached if something goes wrong. */
      _exit( 1 );
    }
  client_finish( context );
  
  exit(0);
}
