#include "wp_plugin.h"

#include <stdio.h>
#include <gmodule.h>
#include "wp_plugin.h"

#include "wp.h"
/*#include "wp_frame.h"*/
#include "wp_view.h"
#include "wp_document.h"

#include "wp_slab.h"
#include "wp_cont_slab.h"
#include "wp_word_slab.h"
#include "wp_lbt_slab.h"
#include "wp_st_slab.h"
#include "wp_image_slab.h"


typedef struct
{
  /*WPView *view;*/
  GtkWidget *window;
  GtkWidget *hbox;
  GtkWidget *done;
  GtkWidget *spell;
  gint context;
  guint index;
  guint oldindex;
  guint offs;
  gint handling;
  char *buffer;
  char *result;

  Spot cur;
  Spot end;

  guint idle_tag;

  WPView *view; /* used to keep from duplicating menu items */
} spell_ui_data;

/* i can't figure out how to hang stuff from
   void handled_word_callback (GtkWidget *spell, GnomeSpellInfo *sp)
   so i'll use a global... XXX */

static spell_ui_data *global_sud;


static char *getUIName ()
{
  return "Spelling Checker";
}


static void spell_exit (GtkWidget */*widget*/, gpointer data)
{
  spell_ui_data *sud = (spell_ui_data *) data;
  if (!sud) return;
  gtk_widget_hide (sud->window);
  /* XXX clean up doc spots */
}


void spell_destroy (GtkWidget */*widget*/, gpointer data)
{
  spell_ui_data *sud = (spell_ui_data *) data;
  if (!sud) return;
  gtk_widget_hide (sud->window);
  /* XXX clean up doc spots */
}

void spell_start_check (spell_ui_data *sud);

void handled_word_callback (GtkWidget */*spell*/, GnomeSpellInfo *sp)
{
  spell_ui_data *sud = global_sud; /* XXX */
  if (!sud) return;

  printf ("handled_word_callback called\n");

  printf ("original:'%s'  replacement:'%s'  word:'%s'  offset: %d\n",
	  sp->original,
	  (sp->replacement) ? sp->replacement : "<NULL>",
	  sp->word, sp->offset);

  /*
  for (GSList *w = si->words; w; w=w->next)
    printf ("   -->%s\n", (char *) (w->data));
  */

  /*WPView *view = wp_view_get_focus_view (sud->frame);*/
  WPView *view = WP_VIEW (mdi->active_view);
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return;

  if (sp->replacement)
    doc->replaceWord (sud->cur,
		      sp->replacement,
		      strlen (sp->replacement));

  sud->cur->setSlab (sud->cur->getSlab ()->getNextLeaf ());
  sud->idle_tag = gtk_idle_add ((GtkFunction) spell_start_check, sud);
  /*spell_start_check (sud);*/
}


static spell_ui_data *new_spell_dialog_new (WPView */*view*/)
{
  /*spell_ui_data *sud = (spell_ui_data *) g_malloc (sizeof (spell_ui_data));*/
  spell_ui_data *sud = (spell_ui_data *) calloc (1, sizeof (spell_ui_data));

  /*WPDocument *doc = wp_view_get_document (view);*/
  /*if (!doc) return NULL;*/
  /*sud->view = view;*/

  sud->spell = gnome_spell_new ();
  sud->hbox = gtk_hbox_new (TRUE,0);
  sud->done = gnome_stock_button ("Button_Close");
  sud->done = gtk_button_new_with_label ("Done");
  sud->window = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (sud->window), "Spelling Checker");
  gtk_box_pack_start (GTK_BOX (sud->hbox), sud->done, FALSE,
		      FALSE, 3);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (sud->window)->vbox),
		      sud->spell, FALSE, FALSE, 3);

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (sud->window)->vbox),
		      sud->hbox, FALSE, FALSE, 3);

  gtk_signal_connect (GTK_OBJECT(sud->window), "destroy",
		      (GtkSignalFunc) spell_destroy, sud);

  gtk_signal_connect (GTK_OBJECT (sud->done), "clicked",
		      (GtkSignalFunc) spell_exit, sud);

  gtk_signal_connect (GTK_OBJECT (sud->spell), "handled_word",
		      GTK_SIGNAL_FUNC (handled_word_callback), sud);

  global_sud = sud; /* XXX */

  gtk_widget_show (sud->done);
  gtk_widget_show (sud->hbox);
  gtk_widget_show (sud->spell);


  /*
  sud->cur = doc->newDocumentSpot ();
  sud->end = doc->newDocumentSpot ();
  */

  sud->cur = NULL;
  sud->end = NULL;

  return sud;
}


static spell_ui_data *get_view_data (WPView *view)
{
  if (!view) return NULL;
  /*WPFrame *frame = wp_view_get_frame (view);*/
  /*if (!frame) return NULL;*/

  spell_ui_data *sud;
  /*
  sud = (spell_ui_data *) wp_view_get_plugin_scratch_space (view, "speller");
  */
  sud = (spell_ui_data *) wp_view_get_plugin_scratch_space (view, "speller");

  if (! sud)
    sud = new_spell_dialog_new (view);

  if (! sud)
    return NULL;

  /*wp_view_set_plugin_scratch_space (view, "speller", sud);*/
  wp_view_set_plugin_scratch_space (view, "speller", sud);
  return sud;
}


void spell_start_check (spell_ui_data *sud)
{
  if (!sud) return;
  Slab cur = sud->cur->getSlab ();
  if (!cur) return;
  /*WPView *view = wp_view_get_focus_view (sud->view);*/
  WPView *view = WP_VIEW (mdi->active_view);
  if (!view) return;

  gtk_idle_remove (sud->idle_tag);

  for (;;cur = cur->getNextLeaf ())
    {
      if (!cur) return;

      if (cur->classID () != WordSlabID) continue;

      /*
	if (wp_view_slab_order (sud->view, sud->end->getSlab (), cur))
	{
	printf ("speller reached end\n");
	return;
	}
      */
      WordSlab ws = (WordSlab) cur;

      char *word = ws->getWord ();

      if (!word || strlen (word) == 0)
	continue;

      int result;

      result = gnome_spell_check (GNOME_SPELL (sud->spell), (gchar *) word);
      /*gnome_spell_next (GNOME_SPELL (sud->spell));*/

      printf ("checking '%s'  result=%d\n", word, result);

      if (result)
	{
	  /* highlight the word being checked */
	  wp_view_set_point (view, cur, 0);
	  wp_view_set_mark (view, cur, cur->getNumberOfChildren ());
	  wp_view_scroll_point_into_view (view);
	  wp_view_hl_on (view);
	  wp_view_refresh (view);

	  sud->cur->setSlab (cur);
	  sud->cur->setPosition (0);
	  break;
	}
    }
}


void
do_spelling_check_callback (GtkWidget */*widget*/, gpointer client_data)
{
  printf ("do_spelling_check_callback called\n");

  WPView *view = (WPView *) client_data;
  if (!view) return;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return;

  printf ("  docname is '%s'\n", doc->getDocumentName ());

  Slab start, end;

  if (wp_view_hl_is_on (view))
    {
      printf ("  operating on region\n");
      start = wp_view_get_point (view)->getSlab ();
      end = wp_view_get_mark (view)->getSlab ();
    }
  else
    {
      printf ("  operating on entire document\n");
      Slab root = doc->getRoot ();
      start = root->firstLowestContainer ();
      end = root->lastLowestContainer ();
    }

  /* make sure they are in the right order */
  if (wp_slab_order (end, start))
    {
      Slab t = start; start = end; end = t;
    }

  spell_ui_data *sud = get_view_data (view);
  gtk_widget_show (sud->window);

  /* set up spots to keep track of the progress of the checker */

  if (!sud->cur) sud->cur = doc->newDocumentSpot ();
  if (!sud->end) sud->end = doc->newDocumentSpot ();

  sud->cur->setSlab (start);
  sud->cur->setPosition (0);
  sud->end->setSlab (end);
  sud->end->setPosition (0);

  /* load the checker with the first word */
  /*spell_start_check (sud);*/
  sud->idle_tag = gtk_idle_add ((GtkFunction) spell_start_check, sud);
}


static void newUI (WPView *view)
{
  /* insert a menu item under the Tools menu */

  if (!view) return;
  spell_ui_data *sud = get_view_data (view);
  if (!sud) return;

  if (sud->view) return; /* already done */
  sud->view = view;


  GnomeUIInfo entry[2];
  entry[0].type = GNOME_APP_UI_ITEM;
  entry[0].label = getUIName ();
  entry[0].hint = NULL;
  entry[0].moreinfo = do_spelling_check_callback;
  entry[0].user_data = view;
  entry[0].unused_data = NULL;
  entry[0].pixmap_type = GNOME_APP_PIXMAP_STOCK;
  entry[0].pixmap_info = GNOME_STOCK_MENU_SPELLCHECK;
  entry[0].accelerator_key = 0;
  entry[1].type = GNOME_APP_UI_ENDOFINFO;

  GnomeApp *app = gnome_mdi_get_app_from_view (GTK_WIDGET (view));

  int menu_pos;
  char menu_item_path[ strlen (entry[0].label) + 20 ];
  sprintf (menu_item_path, "Tools/%s", entry[0].label);
  if (gnome_app_find_menu_pos (app->menubar, menu_item_path, &menu_pos))
    return; /* already done */


  gnome_app_insert_menus_with_data (app, "Tools/", entry, view);
}


static void deleteUI (WPView */*view*/)
{
}


static void hideUI (WPView */*view*/)
{
}


static void showUI (WPView */*view*/)
{
}


extern "C"
{
  int wp_plugin_fill_vtable (PluginVTable *pvt);
  char *g_module_check_init (GModule *module);
}


int wp_plugin_fill_vtable (PluginVTable *pvt)
{
  pvt->get_ui_name = getUIName;
  pvt->new_ui = newUI;
  pvt->delete_ui = deleteUI;
  pvt->show_ui = showUI;
  pvt->hide_ui = hideUI;
  return 0;
}


char *g_module_check_init (GModule */*module*/)
{
  printf ("spelling checker -- g_module_check_init called\n");
  return NULL;
}
