/* BLAH BLAH!  BLAHBLAHBLAH!
 * Copyright  1997 The Hungry Programmers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include "wp_plugin.h"
#include "wp_word_slab.h"
/*#include "wp_plugin_api.h"*/
#include "pluginWrapper.h"
#include "wp_associative.h"
#include "html_escapes.h"

#include "wp_slab.h"
#include "wp_cont_slab.h"
#include "wp_word_slab.h"
#include "wp_lbt_slab.h"
#include "wp_st_slab.h"
#include "wp_image_slab.h"
#include "wp_character.h"

#include "plugin_paper_helper.h"

#define DEBUG_PRINT 1
#define BUFFER_SIZE 8193

#include "wp_append_string.h"
#include "html_tags.h"

class htmlIO : public pluginDocument
{
  WPDocument *document;
  Spot spot;

  WPStyleManager *sm;
  WPStyle *style;
  
  FILE *save_file;

  escape_html escape;
  
  // the root of the upside down tag tree
  html_tag *root,*current;

  // value we are parsing is quoted
  int had_quote,had_slash;
  // we are between preformat tags
  int is_pre;
  append_string current_word,tag_name,escape_buffer;
  
  enum parse_state
  {
    parse_normal,   // watch for data or <'s
    parse_tag,      // watch for tag
    parse_post_tag, // watch for > or name/value pairs
    parse_value,    // get value
    parse_escape    // we got an & in the text
  };

  parse_state current_state;

  // current html tag being parsed
  html_tag *current_tag;

  // call with current_word containing tag, returns 1 if current_word
  // was non empty '<'
  int start_tag ()
    {
      if (!*(const char *)current_word)
	return 0;
      //    cout<<"Started tag "<<((char *)current_word)<<"\n";
      current_tag=new html_tag (root->get_style());
      current_tag->set_nv(current_word,"");
      current_word="";
      tag_name="";
      return 1;
    }

  // call with current_word containing name, returns 1 if current_word
  // was non empty
  int start_nvpair(void)
    {
      if (!*(const char *)tag_name)
	return 0;
      //    cout<<" NVP "<<((char *)tag_name)<<"=";
      //    tag_name="";
      return 1;
    }

  // call with current_word containing value
  void end_nvpair(void)
    {
      //    cout<<((char *)current_word)<<"\n";
      // add name/value pair
      current_tag->add(tag_name,current_word);
      current_word="";
      tag_name="";
    }

  // we got the '>'
  void end_tag(void)
    {
      //    cout<<"Ended tag\n";
#     if DEBUG_PRINT
      current_tag->dump(cout);
#     endif
      insert_tag(current_tag);
      current_tag=NULL;
    }

  // save current scratch buffer if it contains anything
  int flush_current(void)
    {
      printf ("htmlIO -- flush_current, current=%p/%p\n",
	      current, current->get_style ());

      // add the current word if we need to
      if (*(const char *)current_word)
	{
	  /* XXX why is this needed? */
	  WPStyle *cur_style = current->get_style();
	  if (cur_style == NULL ||
	      cur_style->getFontName () == NULL ||
	      strlen (cur_style->getFontName ()) == 0)
	    {
	      printf ("ERROR -- htmlIO tried to make word with no font\n");

	      printf ("  htmlIO -- root=%p/%p\n", root, root->get_style ());
	      /*
	      cur_style->
              setFontName ("-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*");
	      */
	      cur_style = root->get_style ();
	    }

	  Slab s = new _WordSlab (cur_style,
				  (char *) current_word,
				  strlen (current_word));
	  document->insertSlab (spot, s);
	  current_word="";
	  return 1;
	}
      return 0;
    }

  // parse a block of html data
  void parse_block(char *buffer, int len)
    {
      int start=0,c;
     
      while (start<len)
	{
	  //cout<<"Start="<<start<<" c="<<buffer[start]<<" current_state="<<(int)current_state<<" len="<<len<<"\n";
	  switch(current_state)
	    {

	    case parse_normal:
	      switch(c=buffer[start++])
		{
		case '<': // start tag
		  if (flush_current())
		    {
		      // in the future this should be
		      //  determined by the tag type
		      Slab s = new _STSlab (current->get_style());
		      document->insertSlab (spot, s);
		    }
		  current_state=parse_tag;
		  break;
		case '&': // start escape
		  current_state=parse_escape;
		  escape_buffer="";
		  break;
		case '\n':
		case '\r':
		  if (is_pre)
		    {
		      flush_current();
		      Slab s = new _LBTSlab (current->get_style(), 2, 0);
		      document->insertSlab (spot, s);
		      break;
		    }
		case ' ':
		case '\t':
		  // add the current word if we need to
		  if (flush_current())
		    {
		      Slab s = new _STSlab (current->get_style());
		      document->insertSlab (spot, s);
		    }
		  break;
		default:
		  current_word+=c;
		}
	      break;
           
	    case parse_tag:
	      switch(c=buffer[start++])
		{
		case '>':
		  if (start_tag())
		    end_tag();
		  else
		    cerr<<"ERROR: Empty tag\n";
		  current_state=parse_normal;
		  break;
		default:
		  if (isspace(c))
		    {
		      // if we had an acceptable tag and now have a space go
		      // onto the next step. Space after < then keep trying.
		      if (start_tag())
			current_state=parse_post_tag;
		    }
		  else
		    current_word+=tolower(c);
		}
	      break;
          
	    case parse_post_tag:
	      switch(c=buffer[start++])
		{
		case '>':
		  if (start_nvpair())
		    end_nvpair();
		  end_tag();
		  current_state=parse_normal;
		  break;
		case '=':
		  had_quote=0;
		  had_slash=0;
		  if (!start_nvpair())
		    {
		      cerr<<"Empty name in tag NV pair\n";
		      break;
		    }
		  current_state=parse_value;
		  break;
		default:
		  if (isspace(c))
		    {
		      // it may be a name by itself
		      if (start_nvpair())
			end_nvpair();
		    }
		  else
		    tag_name+=tolower(c);
		}
	      break;
           
	    case parse_value:
	      switch(c=buffer[start++])
		{
		case '>':
		  if (had_quote)
		    {
		      current_word+=c;
		      cout<<"Got > but in quotes\n";
		      break;
		    }
		  end_nvpair();
		  end_tag();
		  current_state=parse_normal;
		  break;
		case '\\':
		  if (had_slash)
		    {
		      current_word+=c;
		      had_slash=0;
		    }
		  else
		    had_slash=1;
		  break;
		case '\"':
		  // escape quote
		  if (had_slash)
		    {
		      current_word+=c;
		      break;
		    }
		  // we already had a naked quote, this quote ends the
		  // value.
		  if (had_quote)
		    {
		      current_state=parse_post_tag;
		      end_nvpair();
		      break;
		    }
		  had_quote++;
		  break;
		default:
		  if (isspace(c) && !had_quote)
		    {
		      end_nvpair();
		      current_state=parse_post_tag;
		    }
		  else
		    current_word+=c;
		}
	      if (c!='\\')
		had_slash=0;
	      break;
         
	    case parse_escape:
	      switch(c=buffer[start++])
		{
		case ';': // end of escape
		  // lookup the escape
		  unsigned char escaped_char;
		  if ((escaped_char=escape.get_char(escape_buffer)))
		    current_word+=(char)escaped_char;
		  else
		    // unknown escape, stick it in as is
		    {
		      current_word+='&';
		      /* this didn't work for me...? */
		      /*current_word+=(const char *)escape_buffer;*/
		      for (char *p = escape_buffer; *p != '\0'; p++)
			current_word += (char)(*p);
		      current_word+=';';
		    }
		  current_state=parse_normal;
		  break;
		default:
		  escape_buffer+=c;
		}
	      break;
          
	    default:
	      cout<<"Invalid parser state\n";
	      return;
	    }
	}
    }

  //
  // Higher level stuff, works on the parsed tags
  //

  // deal with a close tag
  void close_tag(const char *tag)
    {
      html_tag *tmp;
      int done=0;
      // search the stack for the opening
      for(tmp=current;tmp && (tmp!=root) && strcmp(tag,tmp->name_of());tmp=tmp->next_tag());
      if (!tmp || (tmp==root))
	{
	  cerr<<"Tag /"<<tag<<" without an opening tag\n";
	  return;
	}
      // go and dereference everything on the way
      do
	{
	  tmp=current->next_tag();
	  done=!strcmp(current->name_of(),tag);
	  // if its not at the top warn
	  if (!done)
	    cerr<<"Warning open "<<current->name_of()<<" with no close\n";
	  html_tag::dereference(current);
	  current=tmp;
	}
      while(!done);
    }

#define CASE(name) \
} \
else if (!strcmp(tag_name,(name))) \
{

  // insert a parsed tag into the document at the current location
  void insert_tag(html_tag *tag)
    {
      const char *tag_name=tag->name_of();
      /*
      if (*tag_name=='/')
	{
	  close_tag(tag_name+1);
	  delete tag;
	  return;
	}
      */
      // trivial test, this should make the file atleast readable
      if (0){
	CASE("/p")
	  {
	    Slab s = new _LBTSlab (current->get_style(), 2, 0);
	    document->insertSlab (spot, s);
	  }
	CASE("br")
	  {
	    Slab s = new _LBTSlab (current->get_style(), 2, 0);
	    document->insertSlab (spot, s);
	  }
	CASE("hr")
	  {
	    Slab s = new _LBTSlab (current->get_style(), 2, 0);
	    document->insertSlab (spot, s);
	  }
	CASE("/td")
	  {
	    Slab s = new _LBTSlab (current->get_style(), 2, 0);
	    document->insertSlab (spot, s);
	  }
	CASE("center")
	  {
	    Slab s = new _LBTSlab (current->get_style(), 2, 0);
	    document->insertSlab (spot, s);
	    setLineAlignment (spot, ALIGN_CENTER);
	  }
	CASE("/center")
	  {
	    Slab s = new _LBTSlab (current->get_style(), 2, 0);
	    document->insertSlab (spot, s);
	    setLineAlignment (spot, ALIGN_LOW);
	  }
	CASE("dd")
	  {
	    Slab s = new _LBTSlab (current->get_style(), 2, 0);
	    document->insertSlab (spot, s);
	  }
	CASE("dt")
	  {
	    Slab s = new _LBTSlab (current->get_style(), 2, 0);
	    document->insertSlab (spot, s);
	  }
      }

      if (*tag_name=='/')
	{
	  close_tag(tag_name+1);
	  delete tag;
	  return;
	}

      // attach tag to the current stack
      tag->build_style (sm, current);
      current=tag;
    }
 public:
  htmlIO(void)
    {
      cerr<<"Constructed html\n";
      document=NULL;
      root=NULL;
    }
    
  virtual ~htmlIO()
    {
      if (root)
	delete root;
    }


  void setLineAlignment (Spot spot, WPAlignment align)
    {
      if (!spot) return;
      Slab cur = spot->getSlab ();
      if (!cur) return;
      cur = cur->getParent ();
      if (!cur) return;

      WPStyle *s = cur->getStyle ();
      if (s->getAlignment () == align)
	return;

      style_group *sg = sm->getStyleGroupByName ("line");

      WPStyle *ns =
	sm->findOrCreateStyle (sg,
			       s->getFontName (), s->getForeground (),
			       s->getBackground (), align,
			       s->getDirection (), s->getXSizePolicy (),
			       s->getYSizePolicy (), s->getFixedLeft (),
			       s->getFixedUp (), s->getFixedRight (),
			       s->getFixedDown (), s->getMarginLeft (),
			       s->getMarginUp (), s->getMarginRight (),
			       s->getMarginDown (), s->getMaxChildren (),
			       s->getMarginRendering (),
			       s->getWhenEmpty (),
			       s->getUnderline ());

      document->setLineStyle (sm, spot, ns->getName ());
    }


  WPDocument *newDocument (WPDocument *doc)
    {
      /* XXX */
      /* a starting html document should probably have
	 <html><body>slab</body></html> or something. */

      sm = new WPStyleManager ();

      page_size_info psi;
      psi.width = 614; /* XXX */
      psi.height = 794;
      psi.leftM = 10;
      psi.upM = 10;
      psi.rightM = 10;
      psi.downM = 10;

      Slab root = wp_page_build (wppt_scroll, sm, &psi);

      doc->setRoot (root);

      return doc;
    }


  virtual int processLoadChunk (char *buffer, int buffer_length)
    {
      cerr<<"Processloadchunk len="<<buffer_length<<"\n";
      /*style = WP_GetStyleOfSlab (document, spot);*/
      /*style = spot->getSlab ()->getStyle ();*/
      parse_block(buffer, buffer_length);
      return 0;
    }

  
  virtual void endLoad (void)
    {
      document->deleteDocumentSpot (spot);
    }

  virtual WPDocument *loadDocument (char *from_path, WPDocument *to_doc)
    {
      int fd;
      struct stat stat_buf;
      
      cout<<"Start loading\n";
      
      document = to_doc;

      fd = open(from_path, O_RDONLY);

      if (fd == -1)
        {
          perror ("open");
          fprintf (stderr, "couldn't open input file.\n");
	  /* XXX delete doc */
          return NULL;
        }

      if (fstat(fd, &stat_buf) == -1)
        {
          perror ("stat");
          fprintf (stderr, "couldn't stat input file.\n");
          close(fd);
	  /* XXX delete doc */
          return NULL;
        }


      sm = new WPStyleManager ();
      page_size_info psi;
      psi.width = 614; /* XXX */
      psi.height = 794;
      psi.leftM = 10;
      psi.upM = 10;
      psi.rightM = 10;
      psi.downM = 10;
      Slab root_slab = wp_page_build (wppt_scroll, sm, &psi);
      document->setRoot (root_slab);


      // initialize parsing variables
      is_pre=0;
      current_word="";
      current_state = parse_normal;

      spot = document->newDocumentSpot ();
      
      style = spot->getSlab ()->getStyle ();
      
      style->setFontName("-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*");

#if 0      
      style_group *wsg = sm->newStyleGroup ("word");
      
      GdkColormap *colormap = gtk_widget_get_default_colormap ();
      
      GdkColor *fg = (GdkColor *) malloc (sizeof (GdkColor));
      fg->red = 65535;
      fg->green = 65535;
      fg->blue = 65535;
      gdk_color_alloc (colormap, fg);
              
      GdkColor *bg = (GdkColor *) malloc (sizeof (GdkColor));
      bg->red = 0;
      bg->green = 0;
      bg->blue = 0;
      gdk_color_alloc (colormap, bg);
      
      style = sm->findOrCreateStyle
	(wsg, "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*", fg, bg, 
	 ALIGN_LOW, DIR_RIGHT, SIZE_POLICY_BY_CHILDREN,
	 SIZE_POLICY_BY_CHILDREN, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 MARGIN_RENDERING_POLICY_BLANK, WHEN_EMPTY_REMOVE, 0);
#endif

      if (!style)
	cerr<<"Default style is NULL!!\n";
      
      if (!root)
	root=new html_tag(style);

      // current tag stack
      current=root;

      printf ("htmlIO -- root=%p/%p\n", root, root->get_style ());

      /* XXX */
      char buffer[ 1024 ];
      int got;
      for (;;)
	{
	  got = read (fd, buffer, sizeof (buffer));
	  if (got < 0)
	    perror ("read");
	  if (got < 1)
	    {
	      close (fd);
	      break;
	    }
	  processLoadChunk (buffer, got);
	}
      endLoad ();
      return document;
    }

# if 0
  virtual int startSave(char *to_path, WPDocument *to_doc)
    {

      document = to_doc;
      /*spot = WP_NewSpot (document);*/
      spot = document->newDocumentSpot ();
      
      if (!(save_file=fopen(to_path,"w")))
	{
	  perror("fopen");
	  fprintf(stderr,"Couldn't open output file.\n");
	  return -1;
	}

      return fileno(save_file);
    }

  virtual int processSaveSlab(int fd)
    {
      (void)fd;
      switch (spot->getSlab ()->classID ())
	{
	case WordSlabID:
	  {
	    unsigned int text_length;
	    /*char *text = WP_GetTextOfWord (document, spot, &text_length);*/
	    WordSlab ws = (WordSlab) spot->getSlab ();
	    char *text = ws->getWord ();
	    const char *esc;
	    unsigned char c;
	    while((c=(unsigned char)*text) && (text_length --))
	      {
		if ((esc=escape.get_escape(c)))
		  {
		    fputc('&',save_file);
		    fputs(esc,save_file);
		    fputc(';',save_file);
		  }
		else
		  fputc((char)c,save_file);
		text++;
	      }
	    break;
	  }
	case STSlabID:
	  {
	    fputc(' ',save_file);
	    break;
	  }
	case LBTSlabID:
	  {
	    fputc('\n',save_file);
	    break;
	  }
	case ImageSlabID:
	  {
	    static char *img_text = "[ Image ]";
	    fputs(img_text,save_file);
	    break;
	  }
	default:
	  break;
	}

      /*if (!WP_MoveToNextSlab(document, spot))*/
      Slab next = spot->getSlab ()->getNextLeaf ();
      if (!next) return -1;
      spot->setSlab (next);
      return 0;
    }

  virtual void endSave(int /*fd*/)
    {
      /*WP_DeleteSpot (document, spot);*/
      document->deleteDocumentSpot (spot);

      if (save_file)
	fclose(save_file);
    }
#endif /* 0 */
};


class htmlCap : public pluginCap
 {
  public:
   htmlCap(void)
    {
    }
   virtual ~htmlCap()
    {
    }
   
   // create new plugin document instance
   virtual class pluginDocument *newPluginDocument()
    {
     return new htmlIO();
    }
    
   virtual const char *getUIName(void)
    {
     return _("HTML");
    }
   virtual const char *getFileExtension(void)
    {
     return "html";
    }
   virtual const char *getMimeType(void)
    {
     return "text/html";
    }
   virtual int canLoad(void)
    {
     return 1;
    }
   virtual int canNew(void)
    {
     cerr<<"html cannew called\n";
     return 1;
    }
   virtual int canSave(void)
    {
     return 1;
    }
 };

pluginCap *pluginCapNew(void)
 {
  return new htmlCap;
 }

#if 0
char *plugin_getUIName(void)
{
  return _("HTML");
}

char *plugin_getMimeType(void)
{
  return "text/html";
}

char *plugin_getFileExtensions(void)
{
  return "html";
}

pluginWrapper *plugin_new(void)
{
  return new htmlIO;
}

#endif
