/* BLAH BLAH!  BLAHBLAHBLAH!
 * Copyright  1997 The Hungry Programmers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "html_escapes.h"

// Based on list at  http://www.sandia.gov/sci_compute/symbols.html
static struct escapes html_escapes[]=
 {
  {"AElig",198}, 
  {"Aacute",193}, 
  {"Acirc",194}, 
  {"Agrave",192}, 
  {"Aring",197}, 
  {"Atilde",195}, 
  {"Auml",196}, 
  {"Ccedil",199}, 
  {"ETH",208}, 
  {"Eacute",201}, 
  {"Ecirc",202}, 
  {"Egrave",200}, 
  {"Euml",203}, 
  {"Iacute",205}, 
  {"Icirc",206}, 
  {"Igrave",204}, 
  {"Iuml",207}, 
  {"Ntilde",209}, 
  {"Oacute",211}, 
  {"Ocirc",212}, 
  {"Ograve",210}, 
  {"Oslash",216}, 
  {"Otilde",213}, 
  {"Ouml",214}, 
  {"THORN",222}, 
  {"Uacute",218}, 
  {"Ucirc",219}, 
  {"Ugrave",217}, 
  {"Uuml",220}, 
  {"Yacute",221}, 
  {"aacute",225}, 
  {"acirc",226}, 
  {"acute",180}, 
  {"aelig",230}, 
  {"agrave",224}, 
  {"amp",'&'},   
  {"aring",229}, 
  {"atilde",227}, 
  {"auml",228},
  {"brvbar",166}, 
  {"ccedil",231}, 
  {"cedil",184}, 
  {"cent",162}, 
  {"copy",169}, 
  {"curren",164}, 
  {"deg",176}, 
  {"divide",247}, 
  {"eacute",233}, 
  {"ecirc",234}, 
  {"egrave",232}, 
  {"eth",240}, 
  {"euml",235}, 
  {"frac12",189}, 
  {"frac14",188}, 
  {"frac34",190}, 
  {"gt",'>'},    
  {"iacute",237}, 
  {"icirc",238}, 
  {"iexcl",161}, 
  {"igrave",236}, 
  {"iquest",191}, 
  {"iuml",239}, 
  {"laquo",171},  
  {"lt",'<'},    
  {"macr",175}, 
  {"micro",181}, 
  {"middot",183}, 
  {"nbsp",160}, 
  {"not",172}, 
  {"ntilde",241}, 
  {"oacute",243}, 
  {"ocirc",244}, 
  {"ograve",242}, 
  {"ordf",170}, 
  {"ordm",186}, 
  {"oslash",248}, 
  {"otilde",245}, 
  {"ouml",246}, 
  {"para",182}, 
  {"plusmn",177}, 
  {"pound",163}, 
  {"quot",'\"'},  
  {"raquo",187}, 
  {"reg",174},
  {"sect",167}, 
  {"shy",173}, 
  {"sup1",185}, 
  {"sup2",178}, 
  {"sup3",179}, 
  {"szlig",223}, 
  {"thorn",254}, 
  {"times",215}, 
  {"trade",174}, 
  {"uacute",250}, 
  {"ucirc",251}, 
  {"ugrave",249}, 
  {"uml",168}, 
  {"uuml",252}, 
  {"yacute",253}, 
  {"yen",165},
  {"yuml",255},
 };

#define ESCAPES (sizeof(html_escapes)/sizeof(escapes))

escape_html::escape_html(void)
 {
  int number=ESCAPES,i;
  // create reverse list

  for(i=0;i<256;i++)
   reverse_escapes[i]=NULL;
  // fill in characters that will need escaping when written out

  for(i=0;i<number;i++)
   reverse_escapes[html_escapes[i].value]=&html_escapes[i];
 }

escape_html::~escape_html()
 {
 }

// get character code for the escaped character
int escape_html::get_char(const char *escape)
 {
  // XXX at some point make it a binary search
  int number=ESCAPES,i;
  // a # followed by #'s is a character code
  if (*escape=='#')
   {
    int n=atoi(escape+1);
    if ((n>255)||(n<1))
     // can't deal with >255 yet
     return 0;
    return n;
   }
  for(i=0;i<number;i++)
   if (!strcasecmp(html_escapes[i].name,escape))
    return html_escapes[i].value;
  return 0;
 }

