/* BLAH BLAH!  BLAHBLAHBLAH!
 * Copyright  1997 The Hungry Programmers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include <string.h>
#include <iostream.h>
#include <ctype.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include "wp_plugin.h"
#include "wp_word_slab.h"
/*#include "wp_plugin_api.h"*/
#include "pluginWrapper.h"
#include "wp_associative.h"
#include "html_tags.h"
#include "wp_font.h"

html_tag::html_tag (WPStyle *initial_style)
{
  tag_style=initial_style;

  /*
  if (tag_style == NULL ||
      fontname == tag_style->getFontName () ||
      strlen (tag_style->getFontName ()) == 0)
    {
      style_group *sg = sm->getStyleGroupByName ("html");

      tag_style = sm->findOrCreateStyle
	(sg, "-*-helvetica-medium-r-normal-*-*-100-*-*-*-*-*-*", fg, bg, 
	 ALIGN_LOW, DIR_RIGHT, SIZE_POLICY_BY_CHILDREN,
	 SIZE_POLICY_BY_CHILDREN, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 MARGIN_RENDERING_POLICY_BLANK, WHEN_EMPTY_REMOVE, 0);
    }
  */


  next=NULL;
  reference_count=0;
  depth=0;
}
 
html_tag::~html_tag()
{
  if (next)
    dereference(next);
}

struct tagtype
{
  const char *name;
  int tag_type;
  tag_id id;
};
 
struct tagtype tags[]=
{
  {"a",tag_cant_nest,TAG_A},
  {"address",tag_cant_nest,TAG_ADDRESS},
  {"applet",tag_cant_nest,TAG_APPLET},
  {"area",tag_no_close,TAG_AREA},
  {"b",tag_cant_nest,TAG_B},
  {"basefont",tag_cant_nest,TAG_BASEFONT}, // should check to see it may be nestable
  {"big",tag_can_nest,TAG_BIG},
  {"blink",tag_cant_nest,TAG_BLINK},
  {"blockquote",tag_can_nest,TAG_BLOCKQUOTE},
  {"body",tag_cant_nest,TAG_BODY},
  {"br",tag_no_close,TAG_BR},
  {"caption",tag_cant_nest,TAG_CAPTION},
  {"center",tag_cant_nest,TAG_CENTER},
  {"cite",tag_cant_nest,TAG_CITE},
  {"code",tag_cant_nest,TAG_CODE},
  {"dd",tag_no_close,TAG_DD},
  {"dir",tag_cant_nest,TAG_DIR},
  {"div",tag_cant_nest,TAG_DIV}, // maybe this can nest?
  {"dl",tag_cant_nest,TAG_DL},
  {"dt",tag_no_close,TAG_DT},
  {"em",tag_cant_nest,TAG_EM},
  {"embed",tag_cant_nest,TAG_EMBED},
  {"font",tag_can_nest,TAG_FONT},
  {"form",tag_cant_nest,TAG_FORM},
  {"frame",tag_no_close,TAG_FRAME},
  {"frameset",tag_cant_nest,TAG_FRAMESET},
  {"h1",tag_cant_nest,TAG_H1},
  {"h2",tag_cant_nest,TAG_H2},
  {"h3",tag_cant_nest,TAG_H3},
  {"h4",tag_cant_nest,TAG_H4},
  {"h5",tag_cant_nest,TAG_H5},
  {"h6",tag_cant_nest,TAG_H6},
  {"head",tag_cant_nest,TAG_HEAD},
  {"hr",tag_no_close,TAG_HR},
  {"html",tag_cant_nest,TAG_HTML},
  {"i",tag_cant_nest,TAG_I},
  {"ilayer",tag_can_nest,TAG_ILAYER},
  {"img",tag_no_close,TAG_IMG},
  {"input",tag_no_close,TAG_INPUT},
  {"isindex",tag_no_close,TAG_ISINDEX},
  {"kbd",tag_cant_nest,TAG_KBD},
  {"keygen",tag_no_close,TAG_KEYGEN},
  {"layer",tag_can_nest,TAG_LAYER},
  {"li",tag_no_close,TAG_LI},
  {"link",tag_no_close,TAG_LINK},
  {"map",tag_cant_nest,TAG_MAP},
  {"menu",tag_cant_nest,TAG_MENU},
  {"meta",tag_no_close,TAG_META},
  {"multicol",tag_can_nest,TAG_MULTICOL},
  {"nobr",tag_cant_nest,TAG_NOBR},
  {"noembed",tag_cant_nest,TAG_NOEMBED},
  {"noframes",tag_cant_nest,TAG_NOFRAMES},
  {"nolayer",tag_cant_nest,TAG_NOLAYER},
  {"noscript",tag_cant_nest,TAG_NOSCRIPT},
  {"object",tag_no_close,TAG_OBJECT},
  {"ol",tag_cant_nest,TAG_OL},
  {"option",tag_cant_nest,TAG_OPTION},
  {"p",tag_cant_nest,TAG_P},
  {"param",tag_no_close,TAG_PARAM},
  {"plaintext",tag_no_close,TAG_PLAINTEXT},
  {"pre",tag_cant_nest,TAG_PRE},
  {"s",tag_cant_nest,TAG_S},
  {"script",tag_cant_nest,TAG_SCRIPT},
  {"select",tag_cant_nest,TAG_SELECT},
  {"title",0,TAG_TITLE},
  {NULL,0,(tag_id) 0}
};

// given a higher html_tag, and our own tag data, build a new style
// if needed.
void html_tag::build_style (WPStyleManager *sm, html_tag *higher)
{
  static int style_count=0;
  char style_name[100];
  (next=higher)->reference();
  depth=higher->get_depth()+1;
  sprintf(style_name,"html_style%d",style_count++);
  if (!higher->tag_style)
    {
      cerr<<"Would copy NULL style for "<<style_name<<"\n";
      return;
    }
  
/*  tag_style = sm->copyStyle ("html", style_name, higher->tag_style);*/

  printf ("build_style -- this=%p/%p, parent=%p/%p\n",
	  this, get_style (),
	  higher, higher->get_style ());

  tag_style = higher->tag_style;

  char *newfontname = NULL;
  char *fontname = tag_style->getFontName ();

  // italics just to test it
  if (!strcmp(name_of(),"i"))
    {
      cerr<<"Pre slant name="<<tag_style->getFontName()<<"\n";
      newfontname = setFontSlant (fontname, "i");
      cerr<<"Post slant name="<<tag_style->getFontName()<<"\n";
    }
  // bold
  if (!strcmp(name_of(),"strong"))
    {
      cerr<<"Pre slant name="<<tag_style->getFontName()<<"\n";
      newfontname = setFontWeight (fontname, "bold");
      cerr<<"Post slant name="<<tag_style->getFontName()<<"\n";
    }

  if (newfontname)
    {
      style_group *sg = sm->getStyleGroupByName ("html");
      WPStyle *s = tag_style;
      tag_style =
	sm->findOrCreateStyle (sg,
			       newfontname, s->getForeground (),
			       s->getBackground (), s->getAlignment (),
			       s->getDirection (), s->getXSizePolicy (),
			       s->getYSizePolicy (), s->getFixedLeft (),
			       s->getFixedUp (), s->getFixedRight (),
			       s->getFixedDown (), s->getMarginLeft (),
			       s->getMarginUp (), s->getMarginRight (),
			       s->getMarginDown (), s->getMaxChildren (),
			       s->getMarginRendering (),
			       s->getWhenEmpty (),
			       s->getUnderline ());
      free (newfontname);
    }
   if (!tag_style)
    {
     cerr<<"Failed to create desired style\n";
     tag_style=higher->tag_style;
    }
    
/*  free (fontname);*/
}
