/* BLAH BLAH!  BLAHBLAHBLAH!
 * Copyright  1997 The Hungry Programmers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"
#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include "wp_plugin.h"
#include "wp_word_slab.h"
/*#include "wp_plugin_api.h"*/
#include "wp_document.h"
#include "pluginWrapper.h"

#define DEBUG_PRINT 1

// the current capabilities object, only one should exit
static pluginCap *capabilities=NULL;

/*
 Document loading works, pluginView class is untested.

 - Larry
*/

//
// pluginCap class
//

pluginCap::pluginCap(void)
 {
 }
 
pluginCap::~pluginCap()
 {
 }

// create new plugin instance
pluginDocument *pluginCap::newPluginDocument(void)
 {
  cerr<<"newPluginDocument called without being overloaded!\n";
  return NULL;
 }

pluginView *pluginCap::newPluginView(void)
 {
  cerr<<"newPluginView called without being overloaded!\n";
  return new pluginView();
 }

const char *pluginCap::getUIName(void)
 {
  return "none";
 }

const char *pluginCap::getFileExtension(void)
 {
  return ".none";
 }

const char *pluginCap::getMimeType(void)
 {
  return "none";
 }

int pluginCap::canLoad(void)
 {
  return 0;
 }

int pluginCap::canSave(void)
 {
  return 0;
 }

int pluginCap::canNew(void)
 {
  return 0;
 }

//
// pluginWrapper class
//   

pluginDocument::pluginDocument(void)
{
  static int first_id=0;
  wrapper_id=first_id++;
# if DEBUG_PRINT
  cerr<<"pluginWrapper New plugin ID="<<wrapper_id<<"\n";
# endif // DEBUG_PRINT  
}

pluginDocument::~pluginDocument()
{
# if DEBUG_PRINT
  cerr<<"pluginWrapper Deleted plugin ID="<<wrapper_id<<"\n";
# endif // DEBUG_PRINT  
}


/* these will be overridden by a subclass.  I did this
   because I'm having trouble with the dl stuff under
   FreeBSD... I was getting things like:

   + Probing ./plugins/io/.libs/libhtmlIO.so as plugin.
   + failed - Undefined symbol "___pure_virtual"
       in gwp:./plugins/io/.libs/libhtmlIO.so

   -seth
*/

/*#define OBJECT(doc) ((pluginWrapper *)(doc->plugin_data))*/
#define OBJECT(doc) \
  ((pluginDocument *)(doc->get_plugin_scratch_space ("cpp-wrapper")))
#define VOBJECT(view) \
  ((pluginView *)(wp_view_get_plugin_scratch_space(view,"cpp-wrapper")))


// C++ wrappers

static char *pluginWrapper_getUIName ()
{
 return (char *)capabilities->getUIName();
//  return "CPP";
}


static char *pluginWrapper_getFileExtension ()
{
 return (char *)capabilities->getFileExtension();
//  return ".html";
}


static int pluginWrapper_canLoad ()
 {
  return capabilities->canLoad();
 }

static int pluginWrapper_canSave ()
 {
  return capabilities->canSave();
 }


static int pluginWrapper_canNew ()
 {
  int r=capabilities->canNew();
  cerr<<"canNew="<<r<<"\n";
  return r;
 }

static char *pluginWrapper_getMimeType(void)
 {
  return (char *)capabilities->getMimeType();
 }

static WPDocument *pluginWrapper_newDocument (char *title)
{
  WPDocument *doc = new WPDocument (title);
  
  pluginDocument *plugin=capabilities->newPluginDocument();
  if (!plugin)
   {
    cerr<<"Failed to create plugin instance\n";
    return NULL;
   }

  /* create the plugin object */
  doc->set_plugin_scratch_space ("cpp-wrapper", (void *) plugin);

# if DEBUG_PRINT
  cerr<<"pluginWrapper newDocument() ID="<<OBJECT(doc)->wrapper_id<<"\n";
# endif // DEBUG_PRINT

  return OBJECT(doc)->newDocument (doc);
}


static WPDocument *pluginWrapper_loadDocument (char *from_path)
{

  pluginDocument *plugin=capabilities->newPluginDocument();
  if (!plugin)
   {
    cerr<<"Failed to create plugin instance\n";
    return NULL;
   }

  WPDocument *doc = new WPDocument (from_path);

  /* create the plugin object */
  /*doc->plugin_data=(IOStreamData)(plugin_new());*/
  doc->set_plugin_scratch_space ("cpp-wrapper", (void *) plugin);

# if DEBUG_PRINT
  cerr<<"pluginWrapper loadDocument() ID="<<OBJECT(doc)->wrapper_id<<"\n";
# endif // DEBUG_PRINT

  return OBJECT(doc)->loadDocument (from_path, doc);
}


static int pluginWrapper_saveDocument (WPDocument *doc, char *filename)
{
# if DEBUG_PRINT
  cerr<<"pluginWrapper startDocument() ID="<<OBJECT(doc)->wrapper_id<<"\n";
# endif // DEBUG_PRINT

  return OBJECT(doc)->saveDocument (doc, filename);
}


#if 0 
static void pluginWrapper_endDocument(WPDocument *doc)
{
# if DEBUG_PRINT
  cerr<<"pluginWrapper endDocument()  ID="<<OBJECT(doc)->wrapper_id<<"\n";
# endif // DEBUG_PRINT
  delete OBJECT(doc);
}
#endif /* 0 */


static int pluginWrapper_replaceWord (WPView *view, Spot spot,
				      char *new_word, int new_word_length)

{
  if (!view) return 0;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return 0;

# if DEBUG_PRINT
  cerr<<"pluginWrapper replaceWord() ID="<<OBJECT(doc)->wrapper_id<<"\n";
# endif // DEBUG_PRINT

  return VOBJECT(view)->replaceWord (view, spot, new_word, new_word_length);
}


static int pluginWrapper_deleteChild (WPView *view, Spot spot)
{
  if (!view) return 0;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return 0;

# if DEBUG_PRINT
  cerr<<"pluginWrapper deleteChild() ID="<<OBJECT(doc)->wrapper_id<<"\n";
# endif // DEBUG_PRINT  

  return VOBJECT(view)->deleteChild (view, spot);
}


static int pluginWrapper_insertSlab (WPView *view, Spot spot, Slab slab)
{
  if (!view) return 0;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return 0;

# if DEBUG_PRINT
  cerr<<"pluginWrapper insertSlab() ID="<<OBJECT(doc)->wrapper_id<<"\n";
# endif // DEBUG_PRINT  

  return VOBJECT(view)->insertSlab (view, spot, slab);
}


static Slab pluginWrapper_createFollowingWord (WPView *view, Spot spot)
{
  if (!view) return NULL;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return NULL;

# if DEBUG_PRINT
  cerr<<"pluginWrapper createFollowingWord() ID="<<
    OBJECT(doc)->wrapper_id<<"\n";
# endif // DEBUG_PRINT

  return VOBJECT(view)->createFollowingWord (view, spot);
}


static int pluginWrapper_insertCharacter (WPView *view, Spot spot,
					  unsigned long int c)
{
  if (!view) return 0;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return 0;

# if DEBUG_PRINT
  cerr<<"pluginWrapper insertCharacter() ID="<<OBJECT(doc)->wrapper_id<<"\n";
# endif // DEBUG_PRINT

  return VOBJECT(view)->insertCharacter (view, spot, c);
}

static void pluginWrapper_buttonEvent(WPView *view, GdkEventButton *geb)
 {
  pluginView *pView=VOBJECT(view);
  if (!pView)
   return;
  pView->buttonEvent(view,geb);
 }

static void pluginWrapper_showUI (WPView *view)
 {
  pluginView *pView=VOBJECT(view);
  if (!pView)
   return;
  pView->showUI(view);
 }
 
static void pluginWrapper_hideUI (WPView *view)
 {
  pluginView *pView=VOBJECT(view);
  if (!pView)
   return;
  pView->hideUI(view);
 }

static void pluginWrapper_updateUI (WPView *view)
 {
  pluginView *pView=VOBJECT(view);
  if (!pView)
   return;
  pView->updateUI(view);
 }

static void pluginWrapper_newUI (WPView *view)
 {
  pluginView *pView;
  pView=capabilities->newPluginView();
  wp_view_set_plugin_scratch_space(view,"cpp-wrapper",pView);
 }

static void pluginWrapper_deleteUI (WPView *view)
 {
  pluginView *pView=VOBJECT(view);
  if (!pView)
   return;
  delete pView;
 }

//
// Edit default functions
//

WPDocument *pluginDocument::newDocument(WPDocument */*doc*/)
{
  // empty
  return NULL;
}


WPDocument *pluginDocument::loadDocument (char */*from_path*/,
					 WPDocument */*to_doc*/)
{
  // empty
  printf ("bad -- pluginWrapper::loadDocument got called\n");
  return NULL;
}


int pluginDocument::saveDocument (WPDocument */*doc*/, char */*filename*/)
{
  // empty
  return 0;
}


pluginView::pluginView(void)
 {
  current_insert_style=NULL;
 }
 
pluginView::~pluginView()
 {
 }

int pluginView::replaceWord (WPView *view, Spot spot,
				char *new_word, int new_word_length)
{
  if (!view) return 0;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return 0;

  return doc->replaceWord (spot, new_word, new_word_length);
}


int pluginView::deleteChild (WPView *view, Spot spot)
{
  if (!view) return 0;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return 0;

  return doc->deleteChild (spot);
}

 
int pluginView::insertSlab (WPView *view, Spot spot, Slab slab)
{
  if (!view) return 0;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return 0;

  return doc->insertSlab (spot, slab);
}

 
Slab pluginView::createFollowingWord (WPView *view, Spot spot)
{
  if (!view) return 0;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return 0;

  if (!current_insert_style)
   current_insert_style=spot->getSlab ()->getStyle ();
  return doc->createFollowingWord (spot, current_insert_style);
}

 				     
int pluginView::insertCharacter (WPView *view, Spot spot,
				     unsigned long int c)
{
  if (!view) return 0;
  WPDocument *doc = wp_view_get_document (view);
  if (!doc) return 0;

  if (!current_insert_style)
   current_insert_style=spot->getSlab ()->getStyle ();

  return doc->insertCharacter (spot, c, current_insert_style);
}

void pluginView::buttonEvent (WPView *, GdkEventButton *)
 {
  return;
 }

void pluginView::showUI(WPView *view)
 {
  (void)view;
 }

void pluginView::hideUI(WPView *view)
 {
  (void)view;
 }

void pluginView::updateUI(WPView *view)
 {
  (void)view;
 }


/************************************************************/
/*                 plugin stuff                             */
/************************************************************/


extern "C"
{
  int wp_plugin_fill_vtable (PluginVTable *pvt);
  char *g_module_check_init (GModule *module);
}

char *g_module_check_init (GModule */*module*/)
{
  printf ("C++ Plugin Wrapper -- g_module_check_init called\n");
  return NULL;
}

int wp_plugin_fill_vtable (PluginVTable *pvt)
{
  if (!capabilities)
   // create plugin capabilities object
   capabilities=pluginCapNew();

  pvt->get_file_extension = pluginWrapper_getFileExtension;
  pvt->get_mime_type = pluginWrapper_getMimeType;
  pvt->get_ui_name = pluginWrapper_getUIName;
  pvt->can_load = pluginWrapper_canLoad;
  pvt->can_save = pluginWrapper_canSave;
  pvt->can_new = pluginWrapper_canNew;
  pvt->load_document = pluginWrapper_loadDocument;
  pvt->save_document = pluginWrapper_saveDocument;
  pvt->new_document = pluginWrapper_newDocument;
  pvt->delete_child = pluginWrapper_deleteChild;
  pvt->insert_character = pluginWrapper_insertCharacter;
  pvt->replace_word = pluginWrapper_replaceWord;
  pvt->create_following_word = pluginWrapper_createFollowingWord;
  pvt->insert_slab = pluginWrapper_insertSlab;
  pvt->button_event = pluginWrapper_buttonEvent;
  pvt->new_ui = pluginWrapper_newUI;
  pvt->delete_ui = pluginWrapper_deleteUI;
  pvt->show_ui = pluginWrapper_showUI;
  pvt->hide_ui = pluginWrapper_hideUI;
  pvt->update_ui = pluginWrapper_updateUI;

  return 0;
}
