/* BLAH BLAH!  BLAHBLAHBLAH!
 * Copyright  1997 The Hungry Programmers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "wp_style_manager.h"
#include "wp_commands.h"
#include "wp_view.h"
#include "wp_clipboard.h"
#include "wp_plugin_manager.h"
#include "wp_plugin.h"
#include "wp_print.h"
#include "wp_prefs.h"
#include "wp.h"
#include "wp_mdi_document.h"


void 
file_new_view_cmd_callback (GtkWidget */*widget*/,
			    gpointer /*client_data*/)
{
  if (! mdi->active_view) return;
  WPView *view = WP_VIEW (mdi->active_view);
  WPDocument *doc = wp_view_get_document (view);

  WPMDIDocument *mdi_doc = doc->get_mdi_document ();
  gnome_mdi_add_view (mdi, GNOME_MDI_CHILD (mdi_doc));
  /*
  WPFrame *frame = (WPFrame*)client_data;
  WPView *view = WP_VIEW (gnome_mdi_get_child_from_view (mdi->active_view));
  WPDocument *doc = wp_view_get_document(view);
  WPFrame *new_frame = wp_frame_create ();
  wp_view_set_document (view, doc);
  wp_frame_show(new_frame);
  */
  printf ("write file_new_win_cmd_callback\n");
}


void
file_new_doc_cmd_callback (GtkWidget */*widget*/,
			   gpointer /*client_data*/)
{
  WPPlugin *plugin =
    WPPluginManager::thePluginManager ()->get_plugin_by_name ("gwp");

  WPMDIDocument *child = wp_mdi_document_new (plugin,
					      wp_unique_document_name ());
  gnome_mdi_add_child (mdi, GNOME_MDI_CHILD (child));
  gnome_mdi_add_view (mdi, GNOME_MDI_CHILD (child));

  /*
  WPFrame *frame = (WPFrame *) client_data;
  wp_frame_show_new_document_dialog_window (frame);
  */
}


void
file_new_doc_type_cmd_callback (GtkWidget */*widget*/,
				gpointer /*client_data*/)
{
  /*
  frame_and_plugin *fap = (frame_and_plugin *) client_data;
  wp_frame_set_new_document_dialog_plugin_type (fap->frame, fap->plugin);
  */

  /*free(fap);*/
}


void
file_new_doc_ok_cmd_callback (GtkWidget */*widget*/,
			      gpointer /*client_data*/)
{
# if 0
  WPFrame *frame = (WPFrame *) client_data;

  WPPlugin *plugin;
  plugin = wp_frame_get_new_document_dialog_plugin_type (frame);

  if (plugin == NULL)
    {
      if (WPPluginManager::plugins == NULL)
	{
	  gnome_error_dialog(_("Unknown document type."));
	  return;
	}

      /* they didn't pick one, so take the first one that can new */
      for (GList *cur = WPPluginManager::plugins;
	   cur != NULL;
	   cur = cur->next)
	{
	  WPPlugin *p = (WPPlugin *) cur->data;
	  if (p->canNew ())
	    {
	      plugin = p;
	      break;
	    }
	}

      if (plugin == NULL)
	{
	  gnome_error_dialog(_("Unknown document type."));
	  return;
	}
    }

  GtkWidget *w = wp_frame_get_new_document_dialog_window (frame);
  gtk_widget_hide (w);

  /*WPDocument *new_doc = new WPDocument (NULL);*/
  WPDocument *new_doc = plugin->newDocument (NULL);

  /* XXX */
  /*wp_view_set_document (WP_VIEW (mdi->active_view), new_doc);*/
# endif /* 0 */
}


void
file_new_doc_cancel_cmd_callback (GtkWidget */*widget*/,
				  gpointer /*client_data*/)
{
# if 0
  WPFrame *frame = (WPFrame *) client_data;
  GtkWidget *w = wp_frame_get_new_document_dialog_window (frame);

  gtk_widget_hide (w);
# endif /* 0 */
}


void 
file_printpreview_cmd_callback (GtkWidget */*widget*/,
				gpointer /*client_data*/)
{
}


void 
file_print_cmd_callback (GtkWidget */*widget*/, gpointer /*client_data*/)
{
  if (! mdi->active_view) return;
  WPView *view = WP_VIEW (mdi->active_view);
  WPDocument *doc = wp_view_get_document (view);

  if (doc == NULL)
    return;

  GnomePrinter *printer = gnome_printer_dialog_new_modal ();
  if (printer)
    {
      gwp_print (printer, doc);
      gtk_object_unref (GTK_OBJECT (printer));
    }
}


void
file_close_cmd_callback(GtkWidget */*widget*/,
			gpointer   /*client_data*/)
{
  printf ("close view\n");

  /*gint success =*/ gnome_mdi_remove_view (mdi, mdi->active_view, false);
}


void 
file_quit_cmd_callback(GtkWidget */*widget*/,
		       gpointer   /*client_data*/)
{
  exit(0);
}


void 
edit_undo_cmd_callback(GtkWidget */*widget*/,
		       gpointer   /*client_data*/)
{
}


void 
edit_redo_cmd_callback(GtkWidget */*widget*/,
		       gpointer   /*client_data*/)
{
}


void 
edit_cut_cmd_callback(GtkWidget *widget,
		      gpointer   client_data)
{
  edit_copy_cmd_callback (widget, client_data);
  edit_clear_cmd_callback (widget, client_data);
}


void 
edit_copy_cmd_callback(GtkWidget */*widget*/,
		       gpointer /*client_data*/)
{
  if (! mdi->active_view) return;
  WPView *view = WP_VIEW (mdi->active_view);

  printf ("copy\n");
  wp_clipboard_copy (view,
		     wp_view_get_mark (view),
		     wp_view_get_point (view));
}


void
edit_paste_cmd_callback(GtkWidget */*widget*/,
			gpointer   /*client_data*/)
{
  if (! mdi->active_view) return;
  WPView *view = WP_VIEW (mdi->active_view);
  if (!view) return;

  printf ("paste\n");
  wp_clipboard_paste (view);
}


void 
edit_selectall_cmd_callback(GtkWidget */*widget*/,
			    gpointer   /*client_data*/)
{
}


void 
edit_clear_cmd_callback(GtkWidget */*widget*/,
			gpointer   /*client_data*/)
{
  if (! mdi->active_view) return;
  WPView *view = WP_VIEW (mdi->active_view);
  if (!view) return;

  if (wp_view_hl_is_on (view))
    wp_view_delete_range (view);

# if 0
  Spot mark = wp_view_get_mark (view);
  Spot point = wp_view_get_point (view);

  if (mark->getSlab () == point->getSlab () &&
      mark->getPosition () == point->getPosition ())
    return; /* no text selected */

  /* put c at the low end of the selection,
     put end at the high end of the selection */

  if (wp_view_spot_order (view, mark, point))
    {
      c = mark;
      end = point;
    }
  else
    {
      c = point;
      end = mark;
    }

  while (wp_view_spot_order (view, c, end))
    {
      /* XXX this shouldn't be needed. */
      if (doc->sanityCheckSpots ())
	break;
      if (doc->getPlugin ()->deleteChild (view, c) == 0)
	break;
    }

  wp_view_hl_off (view);
  wp_view_refresh (view); /* XXX this shouldn't be needed */
# endif /* 0 */
}


#if 0
void 
edit_find_cmd_callback(GtkWidget */*widget*/,
		       gpointer   /*client_data*/)
{
  create_find_dialog();
}
#endif /* 0 */


void 
edit_replace_cmd_callback(GtkWidget */*widget*/,
			  gpointer   /*client_data*/)
{
}


void 
view_showrulers_cmd_callback(GtkWidget */*widget*/,
			     gpointer   /*client_data*/)
{
}


#if 0
void
view_vsplit_cmd_callback(GtkWidget */*widget*/,
			 gpointer   client_data)
{
  WPFrame *frame = (WPFrame*)client_data;
  WPView *view = wp_frame_get_focus_view(frame);
  /*GtkWidget *parent = wp_view_get_basewidget(view)->parent;*/
  GtkWidget *parent = view->parent;
  GtkWidget *vpaned = gtk_vpaned_new();
  /*
  WPView *new_view =
    wp_view_create_with_document(frame, wp_view_get_document(view));
  */

  if (wp_frame_get_split_flag (frame))
    return;
  wp_frame_set_split_flag (frame, 1);

  WPView *new_view = wp_view_new (frame, NULL);
  wp_view_set_document (new_view, wp_view_get_document (view));

  wp_frame_add_view (frame, new_view);
  gint width, height;

  if (parent == wp_frame_get_view_parent(frame))
    {
      gtk_paned_gutter_size(GTK_PANED(vpaned), 0);
      
      gdk_window_get_size(parent->window, &width, &height);

      gtk_widget_hide(wp_view_get_basewidget(view));

      gtk_widget_reparent(wp_view_get_basewidget(view), vpaned);

      wp_frame_set_content(frame, vpaned);
      
      gtk_container_add (GTK_CONTAINER(vpaned),
			 wp_view_get_basewidget (new_view));
      
      gtk_widget_set_usize(wp_view_get_basewidget(view), width, height/2);
      gtk_widget_set_usize(wp_view_get_basewidget(new_view), width, height/2);
      wp_view_show(view);
      wp_view_show(new_view);
      gtk_widget_show(vpaned);
    }
  else
    {
      gtk_paned_gutter_size(GTK_PANED(vpaned), 0);
      
      gdk_window_get_size(parent->window, &width, &height);
      
      gtk_widget_reparent(wp_view_get_basewidget(view), vpaned);
      /*gtk_widget_reparent(wp_view_get_basewidget(new_view), vpaned);*/
      gtk_container_add (GTK_CONTAINER(vpaned),
			 wp_view_get_basewidget(new_view));
      
      gtk_container_add(GTK_CONTAINER(parent), vpaned);
      
      gtk_widget_set_usize(wp_view_get_basewidget(view), width, height/2);
      gtk_widget_set_usize(wp_view_get_basewidget(new_view), width, height/2);
      wp_view_show(new_view);
      gtk_widget_show(vpaned);
    }
}
#endif /* 0 */

#if 0
void
view_hsplit_cmd_callback(GtkWidget */*widget*/,
			 gpointer   client_data)
{
  WPFrame *frame = (WPFrame*)client_data;
  WPView *view = wp_frame_get_focus_view(frame);
  GtkWidget *parent = wp_view_get_basewidget(view)->parent;
  GtkWidget *hpaned = gtk_hpaned_new();

  WPView *new_view = wp_view_create (frame);
  wp_view_set_document (new_view, wp_view_get_document (view));

  gint width, height;

  gtk_paned_gutter_size(GTK_PANED(hpaned), 0);

  gdk_window_get_size(parent->window, &width, &height);

  gtk_container_add(GTK_CONTAINER(parent), hpaned);

  gtk_widget_reparent(wp_view_get_basewidget(view), hpaned);
  /*gtk_widget_reparent(wp_view_get_basewidget(new_view), hpaned);*/
  gtk_container_add (GTK_CONTAINER (hpaned),
		     wp_view_get_basewidget(new_view));

  wp_view_show(new_view);

  gtk_widget_show(hpaned);
}
#endif /* 0 */

#if 0
void
view_unsplit_cmd_callback(GtkWidget */*widget*/,
			  gpointer   client_data)
{
  WPFrame *frame = (WPFrame*)client_data;
  WPView *view = wp_frame_get_focus_view(frame);
  GtkWidget *parent = wp_view_get_basewidget(view)->parent;

  wp_frame_set_split_flag (frame, 0);

  if (GTK_IS_PANED(parent))
    {
      GtkPaned *gp = GTK_PANED (parent);
      GtkWidget *parent_parent = parent->parent;
      WPView *other;

      /* unhook the one that we aren't keeping */
      if (gp->child1 == wp_view_get_basewidget(view))
	other = wp_frame_get_view_with_basewidget (frame, gp->child2);
      else
	other = wp_frame_get_view_with_basewidget (frame, gp->child1);

      wp_frame_remove_view (frame, other);
      gtk_widget_reparent(wp_view_get_basewidget(view), parent_parent);
      /* we still need to destroy the paned -- XXX */
      gtk_widget_hide(parent);
      wp_view_destroy (other);
    }
}
#endif /* 0 */


void
view_refresh_cmd_callback(GtkWidget */*widget*/,
			  gpointer   /*client_data*/)
{
  printf ("view refresh?\n");
  /*
  WPFrame *frame = (WPFrame *) client_data;
  wp_frame_refresh (frame);
  */
}


#if 0
void
document_switch_cmd_callback (GtkWidget *widget,
			      gpointer   client_data)
{
  char *end;
  WPFrame *frame = (WPFrame*) client_data;
  WPDocument *doc;
  WPView *view = wp_frame_get_focus_view (frame);
  char *label = get_string_from_menu_item (widget);

  if (!label)
    return;

  printf ("name = %s\n", label);
  end = strrchr (label, '(');
  if (end == NULL)
    {
      return; /* XXX */
    }
  end--;
  *end = 0;
  printf ("name = %s\n", label);
  doc = (WPDocument*) g_hash_table_lookup (WPDocument::documents, label);

  *end = ' ';
  printf ("doc = %p\n", doc);

  if (doc)
    wp_view_set_document(view, doc);
}
#endif /* 0 */


void 
help_about_cmd_callback (GtkWidget */*widget*/,
			 gpointer   /*client_data*/)
{
}


void 
help_license_cmd_callback(GtkWidget */*widget*/,
			  gpointer   /*client_data*/)
{
}


void
plugins_refresh_cmd_callback(GtkWidget */*widget*/,
			     gpointer /* client_data */)
{
}


void 
dump_doc_structure_callback(GtkWidget */*widget*/,
			    gpointer  /*client_data*/)
{
  if (! mdi->active_view) return;
  WPView *view = WP_VIEW (mdi->active_view);
  WPDocument *doc = wp_view_get_document(view);

  if (doc)
    doc->dumpToScreen();
}
