/* BLAH BLAH!  BLAHBLAHBLAH!
 * Copyright  1997 The Hungry Programmers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "wp_utils.h"

/*

 0  char *foundry = (char *) malloc (orig_len + 1);
 1  char *family = (char *) malloc (orig_len + 1);
 2  char *weight = (char *) malloc (orig_len + 1);
 3  char *slant = (char *) malloc (orig_len + 1);
 4  char *sWidth = (char *) malloc (orig_len + 1);
 5  char *adStyle = (char *) malloc (orig_len + 1);
 6   int *pixelSize = (char *) malloc (orig_len + 1);
 7   int *pointSize = (char *) malloc (orig_len + 1);
 8   int resolutionX = (char *) malloc (orig_len + 1);
 9   int *resolutionY = (char *) malloc (orig_len + 1);
10  char *space = (char *) malloc (orig_len + 1);
11  char *averageWidth = (char *) malloc (orig_len + 1);
12  char *registry = (char *) malloc (orig_len + 1);
13  char *encoding = (char *) malloc (orig_len + 1);

*/


char *getFontComponent (char *font_name, unsigned int pos)
{
  char *p, *parts[ 14 ];
  char *scratch;
  char *ret;
  int i;

  if (pos > 13)
    {
      fprintf (stderr, "replaceFontComponent -- pos out of ");
      fprintf (stderr, "range: %d\n", pos);
      return NULL;
    }

  if (font_name == NULL || strcmp (font_name, "") == 0)
    return strdup ("*");

  scratch = strdup (font_name);

  for (i=0, p=scratch+1; i<14 && *p != '\0'; i++)
    {
      parts[ i ] = p;
      for (; *p != '-' && *p != '\0'; p ++)
	;
      *p = '\0';
      p ++;
    }

  ret = strdup (parts[ pos ]);
  free (scratch);

  return ret;
}


char *setFontComponent (char *font_name, unsigned int pos, char *s)
{
  char *p, *parts[ 14 ];
  char *scratch;
  char *new_name;
  int i, len;

  if (pos > 13)
    {
      fprintf (stderr, "replaceFontComponent -- pos out of ");
      fprintf (stderr, "range: %d\n", pos);
      return strdup (font_name);
    }

  if (font_name != NULL && *font_name != '\0')
    scratch = strdup (font_name);
  else
    {
      char *d = "-*-*-*-*-*-*-*-*-*-*-*-*-*-*";
      scratch = strdup (d);
    }

  for (i=0, p=scratch+1; i<14 && (*p) != '\0'; i++)
    {
      parts[ i ] = p;
      for (; *p != '-' && *p != '\0'; p ++)
	;
      *p = '\0';
      p ++;
    }

  if (s == NULL)
    parts[ pos ] = "*";
  else
    parts[ pos ] = s;

  for (i=0, len=0; i<14; i++)
    len += strlen (parts[ i ]);

  new_name = (char *) malloc (len + 17);

  sprintf(new_name, "-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s-%s",
	  parts[ 0 ], parts[ 1 ], parts[ 2 ], parts[ 3 ], 
	  parts[ 4 ], parts[ 5 ], parts[ 6 ], parts[ 7 ], 
	  parts[ 8 ], parts[ 9 ], parts[ 10 ], parts[ 11 ],
	  parts[ 12 ], parts[ 13 ]);

  free (scratch);
  return new_name;
}


char *getFontFoundry (char *font_name)
{
  return getFontComponent (font_name, 0);
}

char *getFontFamily (char *font_name)
{
  return getFontComponent (font_name, 1);
}

char *getFontWeight (char *font_name)
{
  return getFontComponent (font_name, 2);
}

char *getFontSlant (char *font_name)
{
  return getFontComponent (font_name, 3);
}

char *getFontSWidth (char *font_name)
{
  return getFontComponent (font_name, 4);
}

char *getFontAdStyle (char *font_name)
{
  return getFontComponent (font_name, 5);
}

int getFontPixelSize (char *font_name)
{
  int ret;
  char *p = getFontComponent (font_name, 6);
  ret = atoi (p);
  free (p);
  return ret;
}

int getFontPointSize (char *font_name)
{
  int ret;
  char *p = getFontComponent (font_name, 7);
  ret = atoi (p);
  free (p);
  return ret;
}

int getFontResolutionX (char *font_name)
{
  int ret;
  char *p = getFontComponent (font_name, 8);
  ret = atoi (p);
  free (p);
  return ret;
}

int getFontResolutionY (char *font_name)
{
  int ret;
  char *p = getFontComponent (font_name, 9);
  ret = atoi (p);
  free (p);
  return ret;
}

char *getFontSpace (char *font_name)
{
  return getFontComponent (font_name, 10);
}

int getFontAverageWidth (char *font_name)
{
  int ret;
  char *p = getFontComponent (font_name, 11);
  ret = atoi (p);
  free (p);
  return ret;
}

char *getFontRegistry (char *font_name)
{
  return getFontComponent (font_name, 12);
}

char *getFontEncoding (char *font_name)
{
  return getFontComponent (font_name, 13);
}




char *setFontFoundry (char *font_name, char *s)
{
  return setFontComponent (font_name, 0, s);
}

char *setFontFamily (char *font_name, char *s)
{
  return setFontComponent (font_name, 1, s);
}

char *setFontWeight (char *font_name, char *s)
{
  return setFontComponent (font_name, 2, s);
}

char *setFontSlant (char *font_name, char *s)
{
  return setFontComponent (font_name, 3, s);
}

char *setFontSWidth (char *font_name, char *s)
{
  return setFontComponent (font_name, 4, s);
}

char *setFontAdStyle (char *font_name, char *s)
{
  return setFontComponent (font_name, 5, s);
}

char *setFontPixelSize (char *font_name, int i)
{
  return setFontComponent (font_name, 6, itoa (i));
}

char *setFontPointSize (char *font_name, int i)
{
  return setFontComponent (font_name, 7, itoa (i));
}

char *setFontResolutionX (char *font_name, int i)
{
  return setFontComponent (font_name, 8, itoa (i));
}

char *setFontResolutionY (char *font_name, int i)
{
  return setFontComponent (font_name, 9, itoa (i));
}

char *setFontSpace (char *font_name, char *s)
{
  return setFontComponent (font_name, 10, s);
}

char *setFontAverageWidth (char *font_name, int i)
{
  return setFontComponent (font_name, 11, itoa (i));
}

char *setFontRegistry (char *font_name, char *s)
{
  return setFontComponent (font_name, 12, s);
}

char *setFontEncoding (char *font_name, char *s)
{
  return setFontComponent (font_name, 13, s);
}
