/*
 * Copyright  1997 The Hungry Programmers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <stdlib.h>
#include <string.h>
#include "wp_utils.h"
#include "glib.h"


WpPoint newWpPoint (long int x, long int y)
{
  WpPoint r;
  r.x = x;
  r.y = y;
  return r;
}


char *tabber (int d)
{
  static char *scratch = NULL;
  static int scratch_length = 0;

  if (2*d+1 > scratch_length)
    {
      scratch_length = 2*d+1;
      if (scratch == NULL)
	scratch = (char *) malloc (scratch_length);
      else
	scratch = (char *) realloc (scratch, scratch_length);
    }

  scratch[ 0 ] = '\0';
  while (d>0)
    {
      strcat (scratch, "  ");
      d--;
    }

  return scratch;
}


char *wp_resize_maybe (char *data, int *alloced, int szof, int needed)
{
  if (data != NULL && *alloced >= szof * needed)
    return data;

  (*alloced) = szof * needed + 3;

  if (data == NULL)
    return (char *) malloc (*alloced);
  else
    return (char *) realloc (data, *alloced);
}


char *itoa (int i)
{
  static char ret[ 30 ];
  sprintf (ret, "%d", i);
  return ret;
}


char *wp_unique_document_name ()
{
  static int n = 0;
  return g_strdup_printf ("Untitled-%d", ++n);
}
